(benchmark listtest
 :logic AUFLIA

 :extrasorts (T List_T)

 :extrafuns ((nil_List_T List_T)
             (cons_List_T T List_T List_T)
             (head_List_T List_T T)
             (tail_List_T List_T List_T)
             (append_List_T List_T List_T List_T)
             (length_List_T List_T Int)
             (nth_List_T Int List_T T))

;; Nil and cons have different values

 :assumption (forall (?x T) (?y List_T)
                     (not (= (cons_List_T ?x ?y) nil_List_T))
              :pat { (cons_List_T ?x ?y) } )

;; Head and tail as the inverses of cons

 :assumption (forall (?x T) (?y List_T)
                     (and (= (head_List_T (cons_List_T ?x ?y)) ?x)
                          (= (tail_List_T (cons_List_T ?x ?y)) ?y))
              :pat { (cons_List_T ?x ?y) } )

;; Recursive definition of append

 :assumption (forall (?x List_T)
                     (= (append_List_T nil_List_T ?x) ?x)
              :pat { (append_List_T nil_List_T ?x) } )

 :assumption (forall (?x List_T) (?y T) (?z List_T)
                     (= (append_List_T (cons_List_T ?y ?z) ?x)
                        (cons_List_T ?y (append_List_T ?z ?x)))
              :pat { (append_List_T (cons_List_T ?y ?z) ?x) } )

;; The length of lists

 :assumption (= (length_List_T nil_List_T) 0)

 :assumption (forall (?x List_T) (>= (length_List_T ?x) 0)
              :pat { (length_List_T ?x) } )

 :assumption (forall (?x T) (?y List_T)
                     (= (length_List_T (cons_List_T ?x ?y))
                        (+ 1 (length_List_T ?y)))
              :pat { (length_List_T (cons_List_T ?x ?y)) } )

 :assumption (forall (?x List_T) (?y List_T)
                     (= (length_List_T (append_List_T ?x ?y))
                        (+ (length_List_T ?x) (length_List_T ?y)))
              :pat { (length_List_T (append_List_T ?x ?y)) } )

;; The nth element of a list

 :assumption (forall (?x T) (?y List_T) (?z Int)
                     (and (implies (= ?z 1)
                                   (= (nth_List_T ?z (cons_List_T ?x ?y)) ?x))
                          (implies (> ?z 1)
                                   (= (nth_List_T ?z (cons_List_T ?x ?y))
                                      (nth_List_T (- ?z 1) ?y))))
              :pat { (nth_List_T ?z (cons_List_T ?x ?y)) } )

 :assumption (forall (?x List_T) (?y List_T) (?z Int)
                     (and (implies (and (>= ?z 1) (<= ?z (length_List_T ?x)))
                                   (= (nth_List_T ?z (append_List_T ?x ?y))
                                      (nth_List_T ?z ?x)))
                          (implies (and (> ?z (length_List_T ?x))
                                        (<= ?z (length_List_T (append_List_T ?x ?y))))
                                   (= (nth_List_T ?z (append_List_T ?x ?y))
                                      (nth_List_T (- ?z (length_List_T ?x)) ?y))))
              :pat { (nth_List_T ?z (append_List_T ?x ?y)) } )


 :extrafuns ((a T) (b T) (c List_T) (d List_T))

 :formula (not (and
    (= (head_List_T (cons_List_T a nil_List_T)) a)
    (= (tail_List_T (cons_List_T a nil_List_T)) nil_List_T)
    (= (append_List_T (cons_List_T a nil_List_T) (cons_List_T b nil_List_T))
       (cons_List_T a (cons_List_T b nil_List_T)))
    (forall (?x List_T) (?y T) (> (length_List_T (cons_List_T ?y ?x)) (length_List_T ?x)))
    (forall (?x List_T) (?y List_T) (>= (length_List_T (append_List_T ?x ?y))
                                        (length_List_T ?y)))
    (= (nth_List_T 2 (cons_List_T a (cons_List_T b nil_List_T))) b)
    (implies (>= (length_List_T c) 5) 
             (= (nth_List_T 5 (append_List_T c d)) (nth_List_T 5 c)))
    (implies (and (= (length_List_T c) 4) (>= (length_List_T d) 3))
             (= (nth_List_T 6 (append_List_T c d)) (nth_List_T 2 d)))
))
)