#ifndef PARSER_HEADER_FILE
#define PARSER_HEADER_FILE

class BenchmarkC;
class Attribute;
class ListAttribute;
class Status;
class Sort;
class ListSort;
class SortDeclC;
class ListSortDeclC;
class Term;
class ListTerm;
class BindingC;
class ListBindingC;
class Quantifier;
class SymbolRef;
class FunctionDeclC;
class ListFunctionDeclC;
class SortedVariableC;
class ListSortedVariableC;
class SpecConstant;
class MetaConstant;
class Identifier;
class IndexC;
class ListIndexC;
class Annotation;
class ListAnnotation;
class AttrParam;
class SExpr;
class ListSExpr;

typedef union
{
  int int_;
  char char_;
  double double_;
  char* string_;
  BenchmarkC* benchmarkc_;
  Attribute* attribute_;
  ListAttribute* listattribute_;
  Status* status_;
  Sort* sort_;
  ListSort* listsort_;
  SortDeclC* sortdeclc_;
  ListSortDeclC* listsortdeclc_;
  Term* term_;
  ListTerm* listterm_;
  BindingC* bindingc_;
  ListBindingC* listbindingc_;
  Quantifier* quantifier_;
  SymbolRef* symbolref_;
  FunctionDeclC* functiondeclc_;
  ListFunctionDeclC* listfunctiondeclc_;
  SortedVariableC* sortedvariablec_;
  ListSortedVariableC* listsortedvariablec_;
  SpecConstant* specconstant_;
  MetaConstant* metaconstant_;
  Identifier* identifier_;
  IndexC* indexc_;
  ListIndexC* listindexc_;
  Annotation* annotation_;
  ListAnnotation* listannotation_;
  AttrParam* attrparam_;
  SExpr* sexpr_;
  ListSExpr* listsexpr_;
} YYSTYPE;

#define _ERROR_ 258
#define _SYMB_0 259
#define _SYMB_1 260
#define _SYMB_2 261
#define _SYMB_3 262
#define _SYMB_4 263
#define _SYMB_5 264
#define _SYMB_6 265
#define _SYMB_7 266
#define _SYMB_8 267
#define _SYMB_9 268
#define _SYMB_10 269
#define _SYMB_11 270
#define _SYMB_12 271
#define _SYMB_13 272
#define _SYMB_14 273
#define _SYMB_15 274
#define _SYMB_16 275
#define _SYMB_17 276
#define _SYMB_18 277
#define _SYMB_19 278
#define _SYMB_20 279
#define _SYMB_21 280
#define _SYMB_22 281
#define _SYMB_23 282
#define _SYMB_24 283
#define _SYMB_25 284
#define _SYMB_26 285
#define _SYMB_27 286
#define _SYMB_28 287
#define _SYMB_29 288
#define _SYMB_30 289
#define _STRING_ 290

extern YYSTYPE yylval;
BenchmarkC* pBenchmarkC(FILE *inp);
Attribute* pAttribute(FILE *inp);
ListAttribute* pListAttribute(FILE *inp);
Status* pStatus(FILE *inp);
Sort* pSort(FILE *inp);
ListSort* pListSort(FILE *inp);
SortDeclC* pSortDeclC(FILE *inp);
ListSortDeclC* pListSortDeclC(FILE *inp);
Term* pTerm(FILE *inp);
ListTerm* pListTerm(FILE *inp);
BindingC* pBindingC(FILE *inp);
ListBindingC* pListBindingC(FILE *inp);
Quantifier* pQuantifier(FILE *inp);
SymbolRef* pSymbolRef(FILE *inp);
FunctionDeclC* pFunctionDeclC(FILE *inp);
ListFunctionDeclC* pListFunctionDeclC(FILE *inp);
SortedVariableC* pSortedVariableC(FILE *inp);
ListSortedVariableC* pListSortedVariableC(FILE *inp);
SpecConstant* pSpecConstant(FILE *inp);
MetaConstant* pMetaConstant(FILE *inp);
Identifier* pIdentifier(FILE *inp);
IndexC* pIndexC(FILE *inp);
ListIndexC* pListIndexC(FILE *inp);
Annotation* pAnnotation(FILE *inp);
ListAnnotation* pListAnnotation(FILE *inp);
AttrParam* pAttrParam(FILE *inp);
SExpr* pSExpr(FILE *inp);
ListSExpr* pListSExpr(FILE *inp);


#endif
