/*** BNFC-Generated Pretty Printer and Abstract Syntax Viewer ***/

#include "Printer.H"

//You may wish to change render
void PrintAbsyn::render(Char c)
{
  if (c == '{')
  {
     bufAppend('\n');
     indent();
     bufAppend(c);
     _n_ = _n_ + 2;
     bufAppend('\n');
     indent();
  }
  else if (c == '(' || c == '[')
     bufAppend(c);
  else if (c == ')' || c == ']')
  {
     backup();
     bufAppend(c);
     bufAppend(' ');
  }
  else if (c == '}')
  {
     _n_ = _n_ - 2;
     backup();
     backup();
     bufAppend(c);
     bufAppend('\n');
     indent();
  }
  else if (c == ',')
  {
     backup();
     bufAppend(c);
     bufAppend(' ');
  }
  else if (c == ';')
  {
     backup();
     bufAppend(c);
     bufAppend('\n');
     indent();
  }
  else if (c == 0) return;
  else
  {
     bufAppend(c);
     bufAppend(' ');
  }
}
void PrintAbsyn::render(String s)
{
  if(strlen(s) > 0)
  {
    bufAppend(s);
    bufAppend(' ');
  }
}
void PrintAbsyn::indent()
{
  int n = _n_;
  while (n > 0)
  {
    bufAppend(' ');
    n--;
  }
}
void PrintAbsyn::backup()
{
  if (buf_[cur_ - 1] == ' ')
  {
    buf_[cur_ - 1] = 0;
    cur_--;
  }
}
PrintAbsyn::PrintAbsyn(void)
{
  _i_ = 0; _n_ = 0;
  buf_ = 0;
  bufReset();
}

PrintAbsyn::~PrintAbsyn(void)
{
}

char* PrintAbsyn::print(Visitable *v)
{
  _i_ = 0; _n_ = 0;
  bufReset();
  v->accept(this);
  return buf_;
}
void PrintAbsyn::visitBenchmarkC(BenchmarkC*p) {} //abstract class

void PrintAbsyn::visitBenchmark(Benchmark* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  render('(');
  render("benchmark");
  visitIdent(p->symbol_);
  if(p->listattribute_) {_i_ = 0; p->listattribute_->accept(this);}  render(')');

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitAttribute(Attribute*p) {} //abstract class

void PrintAbsyn::visitLogicAttribute(LogicAttribute* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  render(":logic");
  visitIdent(p->symbol_);

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitFamilyAttribute(FamilyAttribute* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  render(":family");
  visitIdent(p->symbol_);

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitAssumptionAttribute(AssumptionAttribute* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  render(":assumption");
  _i_ = 0; p->term_->accept(this);

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitFormulaAttribute(FormulaAttribute* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  render(":formula");
  _i_ = 0; p->term_->accept(this);

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitStatusAttribute(StatusAttribute* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  render(":status");
  _i_ = 0; p->status_->accept(this);

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitExtraSortsAttribute(ExtraSortsAttribute* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  render(":extrasorts");
  render('(');
  if(p->listsortdeclc_) {_i_ = 0; p->listsortdeclc_->accept(this);}  render(')');

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitExtraFunsAttribute(ExtraFunsAttribute* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  render(":extrafuns");
  render('(');
  if(p->listfunctiondeclc_) {_i_ = 0; p->listfunctiondeclc_->accept(this);}  render(')');

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitNotesAttribute(NotesAttribute* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  render(":notes");
  visitString(p->string_);

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitAnnotationAttribute(AnnotationAttribute* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  _i_ = 0; p->annotation_->accept(this);

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitListAttribute(ListAttribute *listattribute)
{
  while(listattribute!= 0)
  {
    if (listattribute->listattribute_ == 0)
    {
      listattribute->attribute_->accept(this);

      listattribute = 0;
    }
    else
    {
      listattribute->attribute_->accept(this);
      render("");
      listattribute = listattribute->listattribute_;
    }
  }
}

void PrintAbsyn::visitStatus(Status*p) {} //abstract class

void PrintAbsyn::visitSatStatus(SatStatus* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  render("sat");

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitUnSatStatus(UnSatStatus* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  render("unsat");

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitUnknownStatus(UnknownStatus* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  render("unknown");

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitSort(Sort*p) {} //abstract class

void PrintAbsyn::visitIdentSort(IdentSort* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  _i_ = 0; p->identifier_->accept(this);

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitCompositeSort(CompositeSort* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  render('(');
  _i_ = 0; p->identifier_->accept(this);
  if(p->listsort_) {_i_ = 0; p->listsort_->accept(this);}  render(')');

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitListSort(ListSort *listsort)
{
  while(listsort!= 0)
  {
    if (listsort->listsort_ == 0)
    {
      listsort->sort_->accept(this);

      listsort = 0;
    }
    else
    {
      listsort->sort_->accept(this);
      render("");
      listsort = listsort->listsort_;
    }
  }
}

void PrintAbsyn::visitSortDeclC(SortDeclC*p) {} //abstract class

void PrintAbsyn::visitSortDecl(SortDecl* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  render('(');
  _i_ = 0; p->identifier_->accept(this);
  visitIdent(p->numeral_);
  if(p->listannotation_) {_i_ = 0; p->listannotation_->accept(this);}  render(')');

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitSortSynonymDecl(SortSynonymDecl* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  render('(');
  _i_ = 0; p->identifier_->accept(this);
  _i_ = 0; p->sort_->accept(this);
  if(p->listannotation_) {_i_ = 0; p->listannotation_->accept(this);}  render(')');

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitListSortDeclC(ListSortDeclC *listsortdeclc)
{
  while(listsortdeclc!= 0)
  {
    if (listsortdeclc->listsortdeclc_ == 0)
    {
      listsortdeclc->sortdeclc_->accept(this);

      listsortdeclc = 0;
    }
    else
    {
      listsortdeclc->sortdeclc_->accept(this);
      render("");
      listsortdeclc = listsortdeclc->listsortdeclc_;
    }
  }
}

void PrintAbsyn::visitTerm(Term*p) {} //abstract class

void PrintAbsyn::visitConstantTerm(ConstantTerm* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  _i_ = 0; p->specconstant_->accept(this);

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitNullaryTerm(NullaryTerm* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  _i_ = 0; p->symbolref_->accept(this);

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitFunctionTerm(FunctionTerm* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  render('(');
  _i_ = 0; p->symbolref_->accept(this);
  if(p->listterm_) {_i_ = 0; p->listterm_->accept(this);}  render(')');

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitLetTerm(LetTerm* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  render('(');
  render("let");
  render('(');
  if(p->listbindingc_) {_i_ = 0; p->listbindingc_->accept(this);}  render(')');
  _i_ = 0; p->term_->accept(this);
  render(')');

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitQuantifierTerm(QuantifierTerm* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  render('(');
  _i_ = 0; p->quantifier_->accept(this);
  render('(');
  if(p->listsortedvariablec_) {_i_ = 0; p->listsortedvariablec_->accept(this);}  render(')');
  _i_ = 0; p->term_->accept(this);
  render(')');

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitAnnotationTerm(AnnotationTerm* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  render('(');
  render("annot");
  _i_ = 0; p->term_->accept(this);
  _i_ = 0; p->annotation_->accept(this);
  render(')');

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitListTerm(ListTerm *listterm)
{
  while(listterm!= 0)
  {
    if (listterm->listterm_ == 0)
    {
      listterm->term_->accept(this);

      listterm = 0;
    }
    else
    {
      listterm->term_->accept(this);
      render("");
      listterm = listterm->listterm_;
    }
  }
}

void PrintAbsyn::visitBindingC(BindingC*p) {} //abstract class

void PrintAbsyn::visitBinding(Binding* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  render('(');
  visitIdent(p->symbol_);
  _i_ = 0; p->term_->accept(this);
  render(')');

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitListBindingC(ListBindingC *listbindingc)
{
  while(listbindingc!= 0)
  {
    if (listbindingc->listbindingc_ == 0)
    {
      listbindingc->bindingc_->accept(this);

      listbindingc = 0;
    }
    else
    {
      listbindingc->bindingc_->accept(this);
      render("");
      listbindingc = listbindingc->listbindingc_;
    }
  }
}

void PrintAbsyn::visitQuantifier(Quantifier*p) {} //abstract class

void PrintAbsyn::visitAllQuantifier(AllQuantifier* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  render("forall");

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitExQuantifier(ExQuantifier* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  render("exists");

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitSymbolRef(SymbolRef*p) {} //abstract class

void PrintAbsyn::visitIdentifierRef(IdentifierRef* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  _i_ = 0; p->identifier_->accept(this);

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitCastIdentifierRef(CastIdentifierRef* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  render('(');
  render("as");
  _i_ = 0; p->identifier_->accept(this);
  _i_ = 0; p->sort_->accept(this);
  render(')');

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitFunctionDeclC(FunctionDeclC*p) {} //abstract class

void PrintAbsyn::visitConstantDecl(ConstantDecl* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  render('(');
  _i_ = 0; p->specconstant_->accept(this);
  _i_ = 0; p->sort_->accept(this);
  if(p->listannotation_) {_i_ = 0; p->listannotation_->accept(this);}  render(')');

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitMetaConstantDecl(MetaConstantDecl* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  render('(');
  _i_ = 0; p->metaconstant_->accept(this);
  _i_ = 0; p->sort_->accept(this);
  if(p->listannotation_) {_i_ = 0; p->listannotation_->accept(this);}  render(')');

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitFunctionDecl(FunctionDecl* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  render('(');
  _i_ = 0; p->identifier_->accept(this);
  if(p->listsort_) {_i_ = 0; p->listsort_->accept(this);}  if(p->listannotation_) {_i_ = 0; p->listannotation_->accept(this);}  render(')');

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitMacroDecl(MacroDecl* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  render('(');
  _i_ = 0; p->identifier_->accept(this);
  render('(');
  if(p->listsortedvariablec_) {_i_ = 0; p->listsortedvariablec_->accept(this);}  render(')');
  _i_ = 0; p->sort_->accept(this);
  _i_ = 0; p->term_->accept(this);
  if(p->listannotation_) {_i_ = 0; p->listannotation_->accept(this);}  render(')');

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitListFunctionDeclC(ListFunctionDeclC *listfunctiondeclc)
{
  while(listfunctiondeclc!= 0)
  {
    if (listfunctiondeclc->listfunctiondeclc_ == 0)
    {
      listfunctiondeclc->functiondeclc_->accept(this);

      listfunctiondeclc = 0;
    }
    else
    {
      listfunctiondeclc->functiondeclc_->accept(this);
      render("");
      listfunctiondeclc = listfunctiondeclc->listfunctiondeclc_;
    }
  }
}

void PrintAbsyn::visitSortedVariableC(SortedVariableC*p) {} //abstract class

void PrintAbsyn::visitSortedVariable(SortedVariable* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  render('(');
  visitIdent(p->symbol_);
  _i_ = 0; p->sort_->accept(this);
  render(')');

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitListSortedVariableC(ListSortedVariableC *listsortedvariablec)
{
  while(listsortedvariablec!= 0)
  {
    if (listsortedvariablec->listsortedvariablec_ == 0)
    {
      listsortedvariablec->sortedvariablec_->accept(this);

      listsortedvariablec = 0;
    }
    else
    {
      listsortedvariablec->sortedvariablec_->accept(this);
      render("");
      listsortedvariablec = listsortedvariablec->listsortedvariablec_;
    }
  }
}

void PrintAbsyn::visitSpecConstant(SpecConstant*p) {} //abstract class

void PrintAbsyn::visitNumConstant(NumConstant* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  visitIdent(p->numeral_);

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitRatConstant(RatConstant* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  visitIdent(p->rational_);

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitHexConstant(HexConstant* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  visitIdent(p->hexadecimal_);

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitBinConstant(BinConstant* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  visitIdent(p->binary_);

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitStringConstant(StringConstant* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  visitString(p->string_);

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitMetaConstant(MetaConstant*p) {} //abstract class

void PrintAbsyn::visitNumMetaConstant(NumMetaConstant* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  render("NUMERAL");

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitRatMetaConstant(RatMetaConstant* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  render("RATIONAL");

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitHexMetaConstant(HexMetaConstant* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  render("HEXADECIMAL");

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitBinMetaConstant(BinMetaConstant* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  render("BINARY");

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitStringMetaConstant(StringMetaConstant* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  render("STRING");

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitIdentifier(Identifier*p) {} //abstract class

void PrintAbsyn::visitSymbolIdent(SymbolIdent* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  visitIdent(p->symbol_);

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitIndexIdent(IndexIdent* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  render('(');
  render("ind");
  visitIdent(p->symbol_);
  if(p->listindexc_) {_i_ = 0; p->listindexc_->accept(this);}  render(')');

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitIndexC(IndexC*p) {} //abstract class

void PrintAbsyn::visitIndex(Index* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  visitIdent(p->numeral_);

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitListIndexC(ListIndexC *listindexc)
{
  while(listindexc!= 0)
  {
    if (listindexc->listindexc_ == 0)
    {
      listindexc->indexc_->accept(this);

      listindexc = 0;
    }
    else
    {
      listindexc->indexc_->accept(this);
      render("");
      listindexc = listindexc->listindexc_;
    }
  }
}

void PrintAbsyn::visitAnnotation(Annotation*p) {} //abstract class

void PrintAbsyn::visitAttrAnnotation(AttrAnnotation* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  visitIdent(p->annotattribute_);
  _i_ = 0; p->attrparam_->accept(this);

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitListAnnotation(ListAnnotation *listannotation)
{
  while(listannotation!= 0)
  {
    if (listannotation->listannotation_ == 0)
    {
      listannotation->annotation_->accept(this);
      render("");
      listannotation = 0;
    }
    else
    {
      listannotation->annotation_->accept(this);
      render("");
      listannotation = listannotation->listannotation_;
    }
  }
}

void PrintAbsyn::visitAttrParam(AttrParam*p) {} //abstract class

void PrintAbsyn::visitSomeAttrParam(SomeAttrParam* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  _i_ = 0; p->sexpr_->accept(this);

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitNoAttrParam(NoAttrParam* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);


  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitSExpr(SExpr*p) {} //abstract class

void PrintAbsyn::visitConstantSExpr(ConstantSExpr* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  _i_ = 0; p->specconstant_->accept(this);

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitSymbolSExpr(SymbolSExpr* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  visitIdent(p->symbol_);

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitParenSExpr(ParenSExpr* p)
{
  int oldi = _i_;
  if (oldi > 0) render(_L_PAREN);

  render('(');
  if(p->listsexpr_) {_i_ = 0; p->listsexpr_->accept(this);}  render(')');

  if (oldi > 0) render(_R_PAREN);

  _i_ = oldi;
}

void PrintAbsyn::visitListSExpr(ListSExpr *listsexpr)
{
  while(listsexpr!= 0)
  {
    if (listsexpr->listsexpr_ == 0)
    {
      listsexpr->sexpr_->accept(this);
      render("");
      listsexpr = 0;
    }
    else
    {
      listsexpr->sexpr_->accept(this);
      render("");
      listsexpr = listsexpr->listsexpr_;
    }
  }
}

void PrintAbsyn::visitInteger(Integer i)
{
  char tmp[16];
  sprintf(tmp, "%d", i);
  bufAppend(tmp);
}
void PrintAbsyn::visitDouble(Double d)
{
  char tmp[16];
  sprintf(tmp, "%g", d);
  bufAppend(tmp);
}
void PrintAbsyn::visitChar(Char c)
{
  bufAppend('\'');
  bufAppend(c);
  bufAppend('\'');
}
void PrintAbsyn::visitString(String s)
{
  bufAppend('\"');
  bufAppend(s);
  bufAppend('\"');
}
void PrintAbsyn::visitIdent(String s)
{
  render(s);
}

ShowAbsyn::ShowAbsyn(void)
{
  buf_ = 0;
  bufReset();
}

ShowAbsyn::~ShowAbsyn(void)
{
}

char* ShowAbsyn::show(Visitable *v)
{
  bufReset();
  v->accept(this);
  return buf_;
}
void ShowAbsyn::visitBenchmarkC(BenchmarkC* p) {} //abstract class

void ShowAbsyn::visitBenchmark(Benchmark* p)
{
  bufAppend('(');
  bufAppend("Benchmark");
  bufAppend(' ');
  visitIdent(p->symbol_);
  bufAppend(' ');
  bufAppend('[');
  if (p->listattribute_)  p->listattribute_->accept(this);
  bufAppend(']');
  bufAppend(' ');
  bufAppend(')');
}
void ShowAbsyn::visitAttribute(Attribute* p) {} //abstract class

void ShowAbsyn::visitLogicAttribute(LogicAttribute* p)
{
  bufAppend('(');
  bufAppend("LogicAttribute");
  bufAppend(' ');
  visitIdent(p->symbol_);
  bufAppend(')');
}
void ShowAbsyn::visitFamilyAttribute(FamilyAttribute* p)
{
  bufAppend('(');
  bufAppend("FamilyAttribute");
  bufAppend(' ');
  visitIdent(p->symbol_);
  bufAppend(')');
}
void ShowAbsyn::visitAssumptionAttribute(AssumptionAttribute* p)
{
  bufAppend('(');
  bufAppend("AssumptionAttribute");
  bufAppend(' ');
  bufAppend('[');
  if (p->term_)  p->term_->accept(this);
  bufAppend(']');
  bufAppend(')');
}
void ShowAbsyn::visitFormulaAttribute(FormulaAttribute* p)
{
  bufAppend('(');
  bufAppend("FormulaAttribute");
  bufAppend(' ');
  bufAppend('[');
  if (p->term_)  p->term_->accept(this);
  bufAppend(']');
  bufAppend(')');
}
void ShowAbsyn::visitStatusAttribute(StatusAttribute* p)
{
  bufAppend('(');
  bufAppend("StatusAttribute");
  bufAppend(' ');
  bufAppend('[');
  if (p->status_)  p->status_->accept(this);
  bufAppend(']');
  bufAppend(')');
}
void ShowAbsyn::visitExtraSortsAttribute(ExtraSortsAttribute* p)
{
  bufAppend('(');
  bufAppend("ExtraSortsAttribute");
  bufAppend(' ');
  bufAppend('[');
  if (p->listsortdeclc_)  p->listsortdeclc_->accept(this);
  bufAppend(']');
  bufAppend(' ');
  bufAppend(')');
}
void ShowAbsyn::visitExtraFunsAttribute(ExtraFunsAttribute* p)
{
  bufAppend('(');
  bufAppend("ExtraFunsAttribute");
  bufAppend(' ');
  bufAppend('[');
  if (p->listfunctiondeclc_)  p->listfunctiondeclc_->accept(this);
  bufAppend(']');
  bufAppend(' ');
  bufAppend(')');
}
void ShowAbsyn::visitNotesAttribute(NotesAttribute* p)
{
  bufAppend('(');
  bufAppend("NotesAttribute");
  bufAppend(' ');
  visitString(p->string_);
  bufAppend(')');
}
void ShowAbsyn::visitAnnotationAttribute(AnnotationAttribute* p)
{
  bufAppend('(');
  bufAppend("AnnotationAttribute");
  bufAppend(' ');
  bufAppend('[');
  if (p->annotation_)  p->annotation_->accept(this);
  bufAppend(']');
  bufAppend(')');
}
void ShowAbsyn::visitListAttribute(ListAttribute *listattribute)
{
  while(listattribute!= 0)
  {
    if (listattribute->listattribute_)
    {
      listattribute->attribute_->accept(this);
      bufAppend(", ");
      listattribute = listattribute->listattribute_;
    }
    else
    {
      listattribute->attribute_->accept(this);
      listattribute = 0;
    }
  }
}

void ShowAbsyn::visitStatus(Status* p) {} //abstract class

void ShowAbsyn::visitSatStatus(SatStatus* p)
{
  bufAppend("SatStatus");
}
void ShowAbsyn::visitUnSatStatus(UnSatStatus* p)
{
  bufAppend("UnSatStatus");
}
void ShowAbsyn::visitUnknownStatus(UnknownStatus* p)
{
  bufAppend("UnknownStatus");
}
void ShowAbsyn::visitSort(Sort* p) {} //abstract class

void ShowAbsyn::visitIdentSort(IdentSort* p)
{
  bufAppend('(');
  bufAppend("IdentSort");
  bufAppend(' ');
  bufAppend('[');
  if (p->identifier_)  p->identifier_->accept(this);
  bufAppend(']');
  bufAppend(')');
}
void ShowAbsyn::visitCompositeSort(CompositeSort* p)
{
  bufAppend('(');
  bufAppend("CompositeSort");
  bufAppend(' ');
  bufAppend('[');
  if (p->identifier_)  p->identifier_->accept(this);
  bufAppend(']');
  bufAppend(' ');
  bufAppend('[');
  if (p->listsort_)  p->listsort_->accept(this);
  bufAppend(']');
  bufAppend(' ');
  bufAppend(')');
}
void ShowAbsyn::visitListSort(ListSort *listsort)
{
  while(listsort!= 0)
  {
    if (listsort->listsort_)
    {
      listsort->sort_->accept(this);
      bufAppend(", ");
      listsort = listsort->listsort_;
    }
    else
    {
      listsort->sort_->accept(this);
      listsort = 0;
    }
  }
}

void ShowAbsyn::visitSortDeclC(SortDeclC* p) {} //abstract class

void ShowAbsyn::visitSortDecl(SortDecl* p)
{
  bufAppend('(');
  bufAppend("SortDecl");
  bufAppend(' ');
  bufAppend('[');
  if (p->identifier_)  p->identifier_->accept(this);
  bufAppend(']');
  bufAppend(' ');
  visitIdent(p->numeral_);
  bufAppend(' ');
  bufAppend('[');
  if (p->listannotation_)  p->listannotation_->accept(this);
  bufAppend(']');
  bufAppend(' ');
  bufAppend(')');
}
void ShowAbsyn::visitSortSynonymDecl(SortSynonymDecl* p)
{
  bufAppend('(');
  bufAppend("SortSynonymDecl");
  bufAppend(' ');
  bufAppend('[');
  if (p->identifier_)  p->identifier_->accept(this);
  bufAppend(']');
  bufAppend(' ');
  bufAppend('[');
  if (p->sort_)  p->sort_->accept(this);
  bufAppend(']');
  bufAppend(' ');
  bufAppend('[');
  if (p->listannotation_)  p->listannotation_->accept(this);
  bufAppend(']');
  bufAppend(' ');
  bufAppend(')');
}
void ShowAbsyn::visitListSortDeclC(ListSortDeclC *listsortdeclc)
{
  while(listsortdeclc!= 0)
  {
    if (listsortdeclc->listsortdeclc_)
    {
      listsortdeclc->sortdeclc_->accept(this);
      bufAppend(", ");
      listsortdeclc = listsortdeclc->listsortdeclc_;
    }
    else
    {
      listsortdeclc->sortdeclc_->accept(this);
      listsortdeclc = 0;
    }
  }
}

void ShowAbsyn::visitTerm(Term* p) {} //abstract class

void ShowAbsyn::visitConstantTerm(ConstantTerm* p)
{
  bufAppend('(');
  bufAppend("ConstantTerm");
  bufAppend(' ');
  bufAppend('[');
  if (p->specconstant_)  p->specconstant_->accept(this);
  bufAppend(']');
  bufAppend(')');
}
void ShowAbsyn::visitNullaryTerm(NullaryTerm* p)
{
  bufAppend('(');
  bufAppend("NullaryTerm");
  bufAppend(' ');
  bufAppend('[');
  if (p->symbolref_)  p->symbolref_->accept(this);
  bufAppend(']');
  bufAppend(')');
}
void ShowAbsyn::visitFunctionTerm(FunctionTerm* p)
{
  bufAppend('(');
  bufAppend("FunctionTerm");
  bufAppend(' ');
  bufAppend('[');
  if (p->symbolref_)  p->symbolref_->accept(this);
  bufAppend(']');
  bufAppend(' ');
  bufAppend('[');
  if (p->listterm_)  p->listterm_->accept(this);
  bufAppend(']');
  bufAppend(' ');
  bufAppend(')');
}
void ShowAbsyn::visitLetTerm(LetTerm* p)
{
  bufAppend('(');
  bufAppend("LetTerm");
  bufAppend(' ');
  bufAppend('[');
  if (p->listbindingc_)  p->listbindingc_->accept(this);
  bufAppend(']');
  bufAppend(' ');
  bufAppend('[');
  if (p->term_)  p->term_->accept(this);
  bufAppend(']');
  bufAppend(' ');
  bufAppend(')');
}
void ShowAbsyn::visitQuantifierTerm(QuantifierTerm* p)
{
  bufAppend('(');
  bufAppend("QuantifierTerm");
  bufAppend(' ');
  bufAppend('[');
  if (p->quantifier_)  p->quantifier_->accept(this);
  bufAppend(']');
  bufAppend(' ');
  bufAppend('[');
  if (p->listsortedvariablec_)  p->listsortedvariablec_->accept(this);
  bufAppend(']');
  bufAppend(' ');
  bufAppend('[');
  if (p->term_)  p->term_->accept(this);
  bufAppend(']');
  bufAppend(' ');
  bufAppend(')');
}
void ShowAbsyn::visitAnnotationTerm(AnnotationTerm* p)
{
  bufAppend('(');
  bufAppend("AnnotationTerm");
  bufAppend(' ');
  bufAppend('[');
  if (p->term_)  p->term_->accept(this);
  bufAppend(']');
  bufAppend(' ');
  bufAppend('[');
  if (p->annotation_)  p->annotation_->accept(this);
  bufAppend(']');
  bufAppend(' ');
  bufAppend(')');
}
void ShowAbsyn::visitListTerm(ListTerm *listterm)
{
  while(listterm!= 0)
  {
    if (listterm->listterm_)
    {
      listterm->term_->accept(this);
      bufAppend(", ");
      listterm = listterm->listterm_;
    }
    else
    {
      listterm->term_->accept(this);
      listterm = 0;
    }
  }
}

void ShowAbsyn::visitBindingC(BindingC* p) {} //abstract class

void ShowAbsyn::visitBinding(Binding* p)
{
  bufAppend('(');
  bufAppend("Binding");
  bufAppend(' ');
  visitIdent(p->symbol_);
  bufAppend(' ');
  bufAppend('[');
  if (p->term_)  p->term_->accept(this);
  bufAppend(']');
  bufAppend(' ');
  bufAppend(')');
}
void ShowAbsyn::visitListBindingC(ListBindingC *listbindingc)
{
  while(listbindingc!= 0)
  {
    if (listbindingc->listbindingc_)
    {
      listbindingc->bindingc_->accept(this);
      bufAppend(", ");
      listbindingc = listbindingc->listbindingc_;
    }
    else
    {
      listbindingc->bindingc_->accept(this);
      listbindingc = 0;
    }
  }
}

void ShowAbsyn::visitQuantifier(Quantifier* p) {} //abstract class

void ShowAbsyn::visitAllQuantifier(AllQuantifier* p)
{
  bufAppend("AllQuantifier");
}
void ShowAbsyn::visitExQuantifier(ExQuantifier* p)
{
  bufAppend("ExQuantifier");
}
void ShowAbsyn::visitSymbolRef(SymbolRef* p) {} //abstract class

void ShowAbsyn::visitIdentifierRef(IdentifierRef* p)
{
  bufAppend('(');
  bufAppend("IdentifierRef");
  bufAppend(' ');
  bufAppend('[');
  if (p->identifier_)  p->identifier_->accept(this);
  bufAppend(']');
  bufAppend(')');
}
void ShowAbsyn::visitCastIdentifierRef(CastIdentifierRef* p)
{
  bufAppend('(');
  bufAppend("CastIdentifierRef");
  bufAppend(' ');
  bufAppend('[');
  if (p->identifier_)  p->identifier_->accept(this);
  bufAppend(']');
  bufAppend(' ');
  bufAppend('[');
  if (p->sort_)  p->sort_->accept(this);
  bufAppend(']');
  bufAppend(' ');
  bufAppend(')');
}
void ShowAbsyn::visitFunctionDeclC(FunctionDeclC* p) {} //abstract class

void ShowAbsyn::visitConstantDecl(ConstantDecl* p)
{
  bufAppend('(');
  bufAppend("ConstantDecl");
  bufAppend(' ');
  bufAppend('[');
  if (p->specconstant_)  p->specconstant_->accept(this);
  bufAppend(']');
  bufAppend(' ');
  bufAppend('[');
  if (p->sort_)  p->sort_->accept(this);
  bufAppend(']');
  bufAppend(' ');
  bufAppend('[');
  if (p->listannotation_)  p->listannotation_->accept(this);
  bufAppend(']');
  bufAppend(' ');
  bufAppend(')');
}
void ShowAbsyn::visitMetaConstantDecl(MetaConstantDecl* p)
{
  bufAppend('(');
  bufAppend("MetaConstantDecl");
  bufAppend(' ');
  bufAppend('[');
  if (p->metaconstant_)  p->metaconstant_->accept(this);
  bufAppend(']');
  bufAppend(' ');
  bufAppend('[');
  if (p->sort_)  p->sort_->accept(this);
  bufAppend(']');
  bufAppend(' ');
  bufAppend('[');
  if (p->listannotation_)  p->listannotation_->accept(this);
  bufAppend(']');
  bufAppend(' ');
  bufAppend(')');
}
void ShowAbsyn::visitFunctionDecl(FunctionDecl* p)
{
  bufAppend('(');
  bufAppend("FunctionDecl");
  bufAppend(' ');
  bufAppend('[');
  if (p->identifier_)  p->identifier_->accept(this);
  bufAppend(']');
  bufAppend(' ');
  bufAppend('[');
  if (p->listsort_)  p->listsort_->accept(this);
  bufAppend(']');
  bufAppend(' ');
  bufAppend('[');
  if (p->listannotation_)  p->listannotation_->accept(this);
  bufAppend(']');
  bufAppend(' ');
  bufAppend(')');
}
void ShowAbsyn::visitMacroDecl(MacroDecl* p)
{
  bufAppend('(');
  bufAppend("MacroDecl");
  bufAppend(' ');
  bufAppend('[');
  if (p->identifier_)  p->identifier_->accept(this);
  bufAppend(']');
  bufAppend(' ');
  bufAppend('[');
  if (p->listsortedvariablec_)  p->listsortedvariablec_->accept(this);
  bufAppend(']');
  bufAppend(' ');
  bufAppend('[');
  if (p->sort_)  p->sort_->accept(this);
  bufAppend(']');
  bufAppend(' ');
  bufAppend('[');
  if (p->term_)  p->term_->accept(this);
  bufAppend(']');
  bufAppend(' ');
  bufAppend('[');
  if (p->listannotation_)  p->listannotation_->accept(this);
  bufAppend(']');
  bufAppend(' ');
  bufAppend(')');
}
void ShowAbsyn::visitListFunctionDeclC(ListFunctionDeclC *listfunctiondeclc)
{
  while(listfunctiondeclc!= 0)
  {
    if (listfunctiondeclc->listfunctiondeclc_)
    {
      listfunctiondeclc->functiondeclc_->accept(this);
      bufAppend(", ");
      listfunctiondeclc = listfunctiondeclc->listfunctiondeclc_;
    }
    else
    {
      listfunctiondeclc->functiondeclc_->accept(this);
      listfunctiondeclc = 0;
    }
  }
}

void ShowAbsyn::visitSortedVariableC(SortedVariableC* p) {} //abstract class

void ShowAbsyn::visitSortedVariable(SortedVariable* p)
{
  bufAppend('(');
  bufAppend("SortedVariable");
  bufAppend(' ');
  visitIdent(p->symbol_);
  bufAppend(' ');
  bufAppend('[');
  if (p->sort_)  p->sort_->accept(this);
  bufAppend(']');
  bufAppend(' ');
  bufAppend(')');
}
void ShowAbsyn::visitListSortedVariableC(ListSortedVariableC *listsortedvariablec)
{
  while(listsortedvariablec!= 0)
  {
    if (listsortedvariablec->listsortedvariablec_)
    {
      listsortedvariablec->sortedvariablec_->accept(this);
      bufAppend(", ");
      listsortedvariablec = listsortedvariablec->listsortedvariablec_;
    }
    else
    {
      listsortedvariablec->sortedvariablec_->accept(this);
      listsortedvariablec = 0;
    }
  }
}

void ShowAbsyn::visitSpecConstant(SpecConstant* p) {} //abstract class

void ShowAbsyn::visitNumConstant(NumConstant* p)
{
  bufAppend('(');
  bufAppend("NumConstant");
  bufAppend(' ');
  visitIdent(p->numeral_);
  bufAppend(')');
}
void ShowAbsyn::visitRatConstant(RatConstant* p)
{
  bufAppend('(');
  bufAppend("RatConstant");
  bufAppend(' ');
  visitIdent(p->rational_);
  bufAppend(')');
}
void ShowAbsyn::visitHexConstant(HexConstant* p)
{
  bufAppend('(');
  bufAppend("HexConstant");
  bufAppend(' ');
  visitIdent(p->hexadecimal_);
  bufAppend(')');
}
void ShowAbsyn::visitBinConstant(BinConstant* p)
{
  bufAppend('(');
  bufAppend("BinConstant");
  bufAppend(' ');
  visitIdent(p->binary_);
  bufAppend(')');
}
void ShowAbsyn::visitStringConstant(StringConstant* p)
{
  bufAppend('(');
  bufAppend("StringConstant");
  bufAppend(' ');
  visitString(p->string_);
  bufAppend(')');
}
void ShowAbsyn::visitMetaConstant(MetaConstant* p) {} //abstract class

void ShowAbsyn::visitNumMetaConstant(NumMetaConstant* p)
{
  bufAppend("NumMetaConstant");
}
void ShowAbsyn::visitRatMetaConstant(RatMetaConstant* p)
{
  bufAppend("RatMetaConstant");
}
void ShowAbsyn::visitHexMetaConstant(HexMetaConstant* p)
{
  bufAppend("HexMetaConstant");
}
void ShowAbsyn::visitBinMetaConstant(BinMetaConstant* p)
{
  bufAppend("BinMetaConstant");
}
void ShowAbsyn::visitStringMetaConstant(StringMetaConstant* p)
{
  bufAppend("StringMetaConstant");
}
void ShowAbsyn::visitIdentifier(Identifier* p) {} //abstract class

void ShowAbsyn::visitSymbolIdent(SymbolIdent* p)
{
  bufAppend('(');
  bufAppend("SymbolIdent");
  bufAppend(' ');
  visitIdent(p->symbol_);
  bufAppend(')');
}
void ShowAbsyn::visitIndexIdent(IndexIdent* p)
{
  bufAppend('(');
  bufAppend("IndexIdent");
  bufAppend(' ');
  visitIdent(p->symbol_);
  bufAppend(' ');
  bufAppend('[');
  if (p->listindexc_)  p->listindexc_->accept(this);
  bufAppend(']');
  bufAppend(' ');
  bufAppend(')');
}
void ShowAbsyn::visitIndexC(IndexC* p) {} //abstract class

void ShowAbsyn::visitIndex(Index* p)
{
  bufAppend('(');
  bufAppend("Index");
  bufAppend(' ');
  visitIdent(p->numeral_);
  bufAppend(')');
}
void ShowAbsyn::visitListIndexC(ListIndexC *listindexc)
{
  while(listindexc!= 0)
  {
    if (listindexc->listindexc_)
    {
      listindexc->indexc_->accept(this);
      bufAppend(", ");
      listindexc = listindexc->listindexc_;
    }
    else
    {
      listindexc->indexc_->accept(this);
      listindexc = 0;
    }
  }
}

void ShowAbsyn::visitAnnotation(Annotation* p) {} //abstract class

void ShowAbsyn::visitAttrAnnotation(AttrAnnotation* p)
{
  bufAppend('(');
  bufAppend("AttrAnnotation");
  bufAppend(' ');
  visitIdent(p->annotattribute_);
  bufAppend(' ');
  bufAppend('[');
  if (p->attrparam_)  p->attrparam_->accept(this);
  bufAppend(']');
  bufAppend(')');
}
void ShowAbsyn::visitListAnnotation(ListAnnotation *listannotation)
{
  while(listannotation!= 0)
  {
    if (listannotation->listannotation_)
    {
      listannotation->annotation_->accept(this);
      bufAppend(", ");
      listannotation = listannotation->listannotation_;
    }
    else
    {
      listannotation->annotation_->accept(this);
      listannotation = 0;
    }
  }
}

void ShowAbsyn::visitAttrParam(AttrParam* p) {} //abstract class

void ShowAbsyn::visitSomeAttrParam(SomeAttrParam* p)
{
  bufAppend('(');
  bufAppend("SomeAttrParam");
  bufAppend(' ');
  bufAppend('[');
  if (p->sexpr_)  p->sexpr_->accept(this);
  bufAppend(']');
  bufAppend(')');
}
void ShowAbsyn::visitNoAttrParam(NoAttrParam* p)
{
  bufAppend("NoAttrParam");
}
void ShowAbsyn::visitSExpr(SExpr* p) {} //abstract class

void ShowAbsyn::visitConstantSExpr(ConstantSExpr* p)
{
  bufAppend('(');
  bufAppend("ConstantSExpr");
  bufAppend(' ');
  bufAppend('[');
  if (p->specconstant_)  p->specconstant_->accept(this);
  bufAppend(']');
  bufAppend(')');
}
void ShowAbsyn::visitSymbolSExpr(SymbolSExpr* p)
{
  bufAppend('(');
  bufAppend("SymbolSExpr");
  bufAppend(' ');
  visitIdent(p->symbol_);
  bufAppend(')');
}
void ShowAbsyn::visitParenSExpr(ParenSExpr* p)
{
  bufAppend('(');
  bufAppend("ParenSExpr");
  bufAppend(' ');
  bufAppend('[');
  if (p->listsexpr_)  p->listsexpr_->accept(this);
  bufAppend(']');
  bufAppend(' ');
  bufAppend(')');
}
void ShowAbsyn::visitListSExpr(ListSExpr *listsexpr)
{
  while(listsexpr!= 0)
  {
    if (listsexpr->listsexpr_)
    {
      listsexpr->sexpr_->accept(this);
      bufAppend(", ");
      listsexpr = listsexpr->listsexpr_;
    }
    else
    {
      listsexpr->sexpr_->accept(this);
      listsexpr = 0;
    }
  }
}

void ShowAbsyn::visitInteger(Integer i)
{
  char tmp[16];
  sprintf(tmp, "%d", i);
  bufAppend(tmp);
}
void ShowAbsyn::visitDouble(Double d)
{
  char tmp[16];
  sprintf(tmp, "%g", d);
  bufAppend(tmp);
}
void ShowAbsyn::visitChar(Char c)
{
  bufAppend('\'');
  bufAppend(c);
  bufAppend('\'');
}
void ShowAbsyn::visitString(String s)
{
  bufAppend('\"');
  bufAppend(s);
  bufAppend('\"');
}
void ShowAbsyn::visitIdent(String s)
{
  bufAppend('\"');
  bufAppend(s);
  bufAppend('\"');
}

