/**
 * This file is part of the SMT-LIB 2 preprocessor.
 * <http://www.cprover.org/SMT-LIB-LSM/>
 *
 * Copyright (C) 2009 Philipp Ruemmer <ph_r@gmx.net>
 *
 * The SMT-LIB 2 preprocessor is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * The SMT-LIB 2 preprocessor is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with the SMT-LIB 2 preprocessor.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <iostream>
#include <vector>
#include <cstdio>

#include "smtlib-absyn.H"
#include "util.H"
#include "smtlib-resolver.H"
#include "smt-back-end/translator.H"

using namespace std;
using namespace SMTLibAbsyn;
using namespace Resolver;

int main(int argc, char ** argv) {

  FILE *input;
  if (argc > 1) {
    input = fopen(argv[1], "r");
    if (!input) {
      fprintf(stderr, "Error opening input file.\n");
      return 1;
    }
  } else
    input = stdin;

  BenchmarkPtr benchmark;
  try {
      benchmark = translateBenchmark(input);
  } catch (TranslationException &e) {
      cerr << "Error: " << e.what() << endl;
      return 1;
  }

//	cout << *benchmark->formula << endl;

  assert(benchmark);

  SMTBackend::FileTemplates templates;
  SMTBackend::Translator translator (templates, cout, benchmark);
  translator.translate();
}
