/**
 * This file is part of the SMT-LIB 2 preprocessor.
 * <http://www.cprover.org/SMT-LIB-LSM/>
 *
 * Copyright (C) 2009 Philipp Ruemmer <ph_r@gmx.net>
 *
 * The SMT-LIB 2 preprocessor is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * The SMT-LIB 2 preprocessor is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with the SMT-LIB 2 preprocessor.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * Parameter struct used in the lineariser of SMT-LIB expression to store
 * the variables bound above each location
 */

#ifndef SMTLIB_PRINTER
#define SMTLIB_PRINTER 1

#include "util.H"
#include "refcounting.H"

#include <string>

namespace SMTLibAbsyn {

typedef CountingPtr<SinglyLinkedList<std::string> > StringListPtr;

struct PrinterArgument {
    StringListPtr boundVariables;
    std::string prefix;

    PrinterArgument()
        : boundVariables(0), prefix("") {}

    PrinterArgument(const StringListPtr& boundVariables,
                    const std::string prefix)
        : boundVariables(boundVariables), prefix(prefix) {}
};

}

#endif
