/**
 * This file is part of the SMT-LIB 2 preprocessor.
 * <http://www.cprover.org/SMT-LIB-LSM/>
 *
 * Copyright (C) 2009 Philipp Ruemmer <ph_r@gmx.net>
 *
 * The SMT-LIB 2 preprocessor is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * The SMT-LIB 2 preprocessor is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with the SMT-LIB 2 preprocessor.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * The theory of integer arithmetic
 */

#ifndef THEORY_INTEGERS
#define THEORY_INTEGERS 1

#include "empty.H"

namespace Theories {

using namespace SMTLibAbsyn;

class Integers : public TheoryHelpers {
public:
    Integers(const Empty& empty);

    const Empty& empty;

    const SortCtorPtr     sort_Int;
    const MonoFunctionPtr fun_unary_minus;
    const MonoFunctionPtr fun_minus;
    const MonoFunctionPtr fun_plus;
    const MonoFunctionPtr fun_times;
    const MonoFunctionPtr fun_leq;
    const MonoFunctionPtr fun_less;
    const MonoFunctionPtr fun_geq;
    const MonoFunctionPtr fun_greater;

    const MultiArityFunctionFamilyPtr multiArityFun_minus;
    const MultiArityFunctionFamilyPtr multiArityFun_plus;
    const MultiArityFunctionFamilyPtr multiArityFun_times;
    const MultiArityFunctionFamilyPtr multiArityFun_leq;
    const MultiArityFunctionFamilyPtr multiArityFun_less;
    const MultiArityFunctionFamilyPtr multiArityFun_geq;
    const MultiArityFunctionFamilyPtr multiArityFun_greater;

    void registerSymbols(Environment& env) const;
    void registerSymbolsLocally(Environment& env) const;
    void visit(const FunctionAppPtr& node, FunctionVisitor& visitor) const;
    bool visitLocally(const FunctionAppPtr& node, FunctionVisitor& visitor) const;

    const Empty& getEmpty() const;
};

}

#endif
